//-*-c++-*------------------------------------------------------------
//
// File name : bioArithUnaryExpression.h
// Author :    Michel Bierlaire
// Date :      Wed Apr 13 15:19:16 2011
//
//--------------------------------------------------------------------

#ifndef bioArithUnaryExpression_h
#define bioArithUnaryExpression_h


#include "bioExpression.h"

/*!
Class implementing a node of the tree representing a sum expression
*/
class bioArithUnaryExpression : public bioExpression {

public:
  
  bioArithUnaryExpression(bioExpressionRepository* rep, 
			  patULong par,
			  patULong c,
			  patError*& err) ;

  ~bioArithUnaryExpression() ;

public:
  virtual bioExpression* getChild() const ;

  virtual patString getExpression(patError*& err) const ;
  virtual patBoolean isSimple() const ;
  virtual patULong getNumberOfOperations() const ;
  virtual patBoolean dependsOf(patULong aLiteralId) const ;

  virtual void forceCodeGeneration() ;
  virtual patBoolean containsAnIterator() const ;
  virtual patBoolean containsAnIntegral() const ;
  virtual patBoolean containsASequence() const ;

  virtual void simplifyZeros(patError*& err)  ;
  virtual void generateGslFunctions(ostream& str_h,patString prefix,patError*& err)  ;
  virtual patString getIncludeStatements(patString prefix) const  ;

  virtual void setVariables(const patVariables* x) ;
  virtual void setDraws(const vector< vector<patReal> >* d) ;
  virtual void setSample(const bioSample* s) ;
  virtual void setCurrentSpan(bioIteratorSpan aSpan) ;
  virtual void setThreadSpan(bioIteratorSpan aSpan) ;
  virtual void collectExpressionIds(set<patULong>* s) const  ;
  virtual patString check(patError*& err) const  ;

protected:

  patULong childId ;
  bioExpression* child ;

};

#endif

