from biogeme import *
def nullLoglikelihood(availability,iterator):
    total = 0 
    for i,a in availability.items() :
        total += a
    nl = -Sum(log(total),iterator)
    BIOGEME_OBJECT.STATISTICS['Null loglikelihood'] = nl
    return nl

def nullLoglikelihood_ex(availability,iterator,exclude):
    total = 0 
    for i,a in availability.items() :
        total += a
    nl = -Sum(exclude * 0 + (1-exclude) * log(total),iterator)
    BIOGEME_OBJECT.STATISTICS['Null loglikelihood'] = nl
    return nl

def choiceStatistics(choiceSet,choice,iterator):
    # Note that availability is ignored here
    n = {}
    for i in choiceSet:
        n[i] = Sum(choice == i,iterator)
    for i in choiceSet:
        s = 'Alt. %d chosen' % (i)
        BIOGEME_OBJECT.STATISTICS[s] = n[i]
    return n

def availabilityStatistics(availability,iterator):
    n = {}
    for i,a in availability.items():
        n[i] = Sum(a,iterator)
    for i,a in availability.items():
        s = 'Alt. %d available' % (i)
        BIOGEME_OBJECT.STATISTICS[s] = n[i]
        

def cteLoglikelihood(choiceSet,choice,iterator):
    n = choiceStatistics(choiceSet,choice,iterator)
    l = 0
    total = 0
    for i in n:
        print(n[i])
        l += n[i] * log(n[i])
        total += n[i]
    l -= total * log(total)
    BIOGEME_OBJECT.STATISTICS['Cte loglikelihood (only for full choice sets)'] = l
    return l

